#include <math.h>
#include "vecdefs.h"
#include <mvm.h>

MATRIX_double bidiag(int n)
 
{
MATRIX_double B(n,n);
  int i;
  int j;
  {
 
    
    for(i = 1;i <= n;i++)
      for(j = 1;j <= n;j++)
        if( j == 1.0+i || j == i )
          B(i-1,j-1) = 1.0;
        else 
          B(i-1,j-1) = 0.0;
 
    return(B);
  }
}


 
MATRIX_double tridiag(const int &n)
{
   
  int i;
  int j;
  {
 
MATRIX_double  B(n,n);
    for(i = 1;i <= n;i++)
      for(j = 1;j <= n;j++)
        if( j == i-1 || j == 1+i || j == i )
          B(i-1,j-1) = 1.0;
        else 
          B(i-1,j-1) = 0.0;
    return(B);
  }
}


MATRIX_double hilbert(int n)
{
  int i;
  int j;
 
  {
  MATRIX_double  A(n,n) ;
    for(i = 1;i <= n;i++)
      for(j = 1;j <= n;j++)
        A(i-1,j-1) = 1/(i+j-1.0);
 
    return(A);
  }
}


