#include <iostream.h>
#include <math.h>
#include <stdlib.h>
#include "vecdefs.h"
#include MATRIX_H 

MATRIX_double cubicspline(VECTOR_double x,VECTOR_double y,double z1,double zn)
{
  int n=x.size(); 
  VECTOR_double dx(n,0);
  VECTOR_double dy(n,0);
   VECTOR_double  z(n,0);
  VECTOR_double   d(n-1,0);
   VECTOR_double  r(n,0);
  VECTOR_double  a(n-1,0) ;
   VECTOR_double  b(n-1,0) ;
  VECTOR_double  c(n-1,0) ;
  MATRIX_double cofs(n-1,4);
  double t;
  
  {
    int i =0;
    z(0) = z1;
    z(n-1) = zn;
    for(i = 1;i <= n-1.0;i++)
    {
      dx(i-1) = x(i)-x(i-1);
      dy(i-1) = y(i)-y(i-1);
    }
    for( i = 1;i <= n-2.0;i++)
    {
      d(i-1) = 2.0*dx(i-1)+2.0*dx(i);
      r(i-1) = 6.0*dy(i)/dx(i)-6.0*dy(i-1)/dx(i-1);
    }
    r(0) += -dx(0)*z(0);
    for(i = 2;i <= n-2.0;i++)
    {
      d(i-1) += -dx(i)*dx(i)/d(i-2);
      r(i-1) += -dx(i-1)*r(i-2)/d(i-2);
    }
    for(i = n-1;2.0 <= i;i--)
      z(i-1) = (r(i-2)-dx(i-1)*z(i))/d(i-2);
    for(i = 1;i <= n-1.0;i++)
    {
      a(i-1) = (z(i)-z(i-1))/dx(i-1)/6.0;
      b(i-1) = z(i-1)/2.0;
      c(i-1) = dy(i-1)/dx(i-1)-a(i-1)*pow(dx(i-1),2.0)-b(i-1)*dx(i-1);
      
    }
    for(i=0;i<n-1;i++)
    {cofs(i,0)=a(i); cofs(i,1)=b(i); cofs(i,2)=c(i); cofs(i,3)=y(i);
     cout << a(i) << "  " << b(i) << "  " << c(i) << "  " << y(i) << endl;}

    return(cofs);
  }
}

