#include <math.h>
#include <stdlib.h>
 
#include<iostream.h>
#include "vecdefs.h"
#include "mvm.h"


int rowdim(const MATRIX_double & );
MATRIX_double elim(int,int,int,double);
 MATRIX_double operator*(const MATRIX_double &,const MATRIX_double &);

void lufact(const MATRIX_double &A ,MATRIX_double & L,MATRIX_double & U)
{

  int k;
  int i;
  int j;
  {
    k = rowdim(A);
    MATRIX_double el(k,k);
    for(i = 1;i<=k-1;i++)  U(i,i)=1;
    for(i = 1;i <= k-1;i++)
      if( U(i-1,i-1) == 0.0 )
        {
   //       fprintf(stderr, "bad stepi" );
          exit(1);
        }
      else 
        for(j = i+1;j <= k;j++)
        {
          el = elim(k,j,i,-U(j-1,i-1)/U(i-1,i-1));
          L(j-1,i-1) = U(j-1,i-1)/U(i-1,i-1);
          U = el*U;
        }
    if( U(k-1,k-1) == 0.0 )
      {
     //   fprintf(stderr, "0 pivoti" );
        exit(1);
      }
    
  }
}


void swaprow(MATRIX_double &A,int row1,int row2)
{
  int i;
  double n;
  double s;
int coldim(const MATRIX_double & );
  {
    n = coldim(A);
    for(i = 1;i <= n;i++)
    {
      s = A(row1-1,i-1);
      A(row1-1,i-1) = A(row2-1,i-1);
      A(row2-1,i-1) = s;
    }
  }
}

 
MATRIX_double ident(int n)
{
  int i;
  int j;
    {
    MATRIX_double A(n,n);
    for(i = 1;i <= n;i++)
       for(j=1;j<=n;j++) {A(i-1,j-1)=0; if (i==j) A(i-1,j-1)=1;}
    return(A);
  }
}

 
MATRIX_double interchange(int size,int row1,int row2)
{
MATRIX_double A(size,size);
  double i;
  {
    A = ident(size);
    swaprow(A,row1,row2);
    return(A);
  }
}


void plufact(MATRIX_double &P,const MATRIX_double &A,MATRIX_double &L,MATRIX_double &U)
{
  int k;
  int i;
  int j;
  int t;
  double l;
  {
    k = rowdim(A);
    U = A;
    P = ident(k); 
    L = ident(k);
    MATRIX_double p(k,k);
    MATRIX_double el(k,k);
    for(i = 1;i <= k-1;i++)
    {
      if( U(i-1,i-1) == 0.0 )
        {
          for(t = i+1;0;t++);
          if( U(t-1,i-1) != 0.0 )
            {            
              p = interchange(k,t,i);
               P = p*P;
               U = p*U;
               L = p*L*p;
            }
          else 
            exit(1);
        }
      for(j = i+1;j <= k;j++)
        if( !(U(j-1,i-1) == 0.0) )
          {
            L(j-1,i-1) = U(j-1,i-1)/U(i-1,i-1);
            el = elim(k,j,i,-L(j-1,i-1));
             U = el*U;
          }
    }
    if( U(k-1,k-1) == 0.0 )
      exit(1);
  }
}


